SystemOrganization addCategory: #MultiQuoAndRem!

Object subclass: #MQARArrayWritter
	instanceVariableNames: 'collection position readLimit writeLimit'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MultiQuoAndRem'!

!MQARArrayWritter commentStamp: 'hjo 7/2/2011 16:28' prior: 0!
I am stripped off version of WriteStream. MultiQuoAndRem can be computed faster by using me than by using OrderedCollection.!

!MQARArrayWritter classSide methodsFor: 'instance creation' stamp: 'hjo 7/2/2011 15:59'!
on: aCollection 
	"Answer an instance of me, streaming over the elements of aCollection."

	^self basicNew on: aCollection! !

!MQARArrayWritter classSide methodsFor: 'instance creation' stamp: 'hjo 7/2/2011 16:10'!
onArrayOfSize: anInteger

	^self on: (Array new: anInteger)! !

!MQARArrayWritter methodsFor: 'accessing' stamp: 'hjo 7/2/2011 16:26'!
array

	^collection! !

!MQARArrayWritter methodsFor: 'accessing' stamp: 'hjo 7/2/2011 15:57'!
nextPut: anObject 
	"Primitive. Insert the argument at the next position in the Stream
	represented by the receiver. Fail if the collection of this stream is not an
	Array or a String. Fail if the stream is positioned at its end, or if the
	position is out of bounds in the collection. Fail if the argument is not
	of the right type for the collection. Optional. See Object documentation
	whatIsAPrimitive."

	<primitive: 66>
	position >= writeLimit
		ifTrue: [^ self pastEndPut: anObject]
		ifFalse: 
			[position := position + 1.
			^collection at: position put: anObject]! !

!MQARArrayWritter methodsFor: 'private' stamp: 'hjo 7/2/2011 15:58'!
on: aCollection

	collection := aCollection.
	readLimit := aCollection size.
	position := 0.
	self reset.
	readLimit := 0.
	writeLimit := aCollection size! !

!MQARArrayWritter methodsFor: 'positioning' stamp: 'hjo 7/2/2011 15:58'!
reset
	"Set the receiver's position to the beginning of the sequence of objects."

	position := 0! !

Object subclass: #MultiQuoAndRem
	instanceVariableNames: 'dividers'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MultiQuoAndRem'!

!MultiQuoAndRem methodsFor: 'accessing' stamp: 'hjo 3/24/2008 10:38'!
dividers

	^dividers
! !

!MultiQuoAndRem methodsFor: 'accessing' stamp: 'hjo 3/24/2008 10:38'!
dividers: anArray 

	^dividers := anArray! !

!MultiQuoAndRem methodsFor: 'initialize-release' stamp: 'hjo 3/24/2008 10:38'!
forClock

	^self new dividers: #(24 60 60); yourself! !

!MultiQuoAndRem methodsFor: 'initialize-release' stamp: 'hjo 3/24/2008 10:38'!
forYearMonthDayHourMinuteSecond

	^super new dividers: #(12 30 24 60 60); yourself! !

!MultiQuoAndRem methodsFor: 'evaluating' stamp: 'hjo 2/22/2012 19:55'!
indexValue: aNumber

	|number indexArray reverseIndex |
	number := aNumber.
	
	indexArray := Array new: self dividers size.

	reverseIndex := indexArray size.
	self dividers reverseDo: [:each| | qr |
		indexArray at: reverseIndex put: ((number \\ each)+1).
		number := number // each.
		reverseIndex := reverseIndex -1.
		].

	^indexArray! !

!MultiQuoAndRem methodsFor: 'evaluating' stamp: 'HwaJong 12/25/2012 22:37'!
unIndexValue: anArray 
	| base0Indices multiplier sum |
	base0Indices := anArray -1.
	multiplier := 1.
	sum := 1.
	base0Indices size to: 1 by: -1 do: [:i|
		|base0|
		base0 := base0Indices at: i.
		sum := sum + (multiplier*base0).
		multiplier := multiplier * (dividers at: i). 
		].
	^sum! !

!MultiQuoAndRem methodsFor: 'evaluating' stamp: 'hjo 3/24/2008 10:38'!
unValue: anArray 

	|sum stream dStream|
	stream := anArray readStream.
	dStream := self dividers readStream.
	sum := stream next.
	[ stream atEnd ] whileFalse: [ sum := sum * dStream next + stream next ].
	^sum! !

!MultiQuoAndRem methodsFor: 'evaluating' stamp: 'hjo 7/2/2011 16:26'!
value: aNumber

	|number answer|
	number := aNumber.
	answer := MQARArrayWritter onArrayOfSize: self dividers size + 1.

	self dividers reverseDo: [:each| | qr |
		answer nextPut: (number \\ each).
		number := number // each].

	answer nextPut: number.

	^answer array reverse
	! !

TestCase subclass: #MultiQuoAndRemTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MultiQuoAndRem'!

!MultiQuoAndRemTest methodsFor: 'as yet unclassified' stamp: 'hjo 3/24/2008 10:38'!
testClock

	self assert:
		(MultiQuoAndRem new
			dividers: #(24 60 60);
			value: 650021 ) = #( 7 12 33 41 )! !

!MultiQuoAndRemTest methodsFor: 'as yet unclassified' stamp: 'HwaJong 12/25/2012 20:37'!
testIndexValue

	| mq |
	mq := MultiQuoAndRem new.
	mq dividers: #(2 5). 
	self assert: (mq unIndexValue: #(1 1) ) = 1.
	self assert: (mq unIndexValue: #(2 1) ) = 6.
	self assert: (mq unIndexValue: #(3 1) ) = 11.! !

!MultiQuoAndRemTest methodsFor: 'as yet unclassified' stamp: 'HwaJong 12/25/2012 22:14'!
testIndexValue2

	| mq |
	mq := MultiQuoAndRem new.
	mq dividers: #(3 2 5). 
	self assert: (mq unIndexValue: #(1 1 1) ) = 1.
	self assert: (mq unIndexValue: #(1 2 1) ) = 6.
	self assert: (mq unIndexValue: #(2 1 1) ) = 11.
	self assert: (mq unIndexValue: #(2 2 1) ) = 16.
	self assert: (mq unIndexValue: #(3 1 1) ) = 21.
	self assert: (mq unIndexValue: #(3 2 1) ) = 26.
! !

!MultiQuoAndRemTest methodsFor: 'as yet unclassified' stamp: 'HwaJong 12/25/2012 20:17'!
testUnIndexValue

	self assert:
		(MultiQuoAndRem new
			dividers: #(24 60 60);
			indexValue: 650021 ) = #( 13 34 42 )! !

!MultiQuoAndRemTest methodsFor: 'as yet unclassified' stamp: 'hjo 6/25/2011 17:56'!
testUnValue

	|mq|
	mq := MultiQuoAndRem new.
	mq dividers: #(26 32).
	self assert: 128 equals: (mq unValue: #(0 4 0))! !

!MultiQuoAndRemTest methodsFor: 'as yet unclassified' stamp: 'hjo 6/25/2011 17:56'!
testUnValue10

	|mq|
	mq := MultiQuoAndRem new.
	mq dividers: #(10 10 10).
	self assert: 1234 equals: (mq unValue: #(1 2 3 4))! !
